/**
 * LDS Token Internal Api
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { HttpService, Injectable, Optional } from '@nestjs/common';
import { AxiosResponse } from 'axios';
import { Observable } from 'rxjs';
import { TransferCommand } from '@/internal/ledius-token';
import { TransferResponse } from '@/internal/ledius-token';
import { Configuration } from '../configuration';

@Injectable()
export class TransferTokenInternalService {
  protected basePath = 'http://localhost';
  public defaultHeaders: Record<string, string> = {};
  public configuration = new Configuration();

  constructor(
    protected httpClient: HttpService,
    @Optional() configuration: Configuration,
  ) {
    this.configuration = configuration || this.configuration;
    this.basePath = configuration?.basePath || this.basePath;
  }
  /**
   *
   *
   * @param transferCommand
   */
  public transfer(
    transferCommand: TransferCommand,
  ): Observable<AxiosResponse<TransferResponse>>;
  public transfer(transferCommand: TransferCommand): Observable<any> {
    if (transferCommand === null || transferCommand === undefined) {
      throw new Error(
        'Required parameter transferCommand was null or undefined when calling transfer.',
      );
    }

    let headers = this.defaultHeaders;

    // to determine the Accept header
    let httpHeaderAccepts: string[] = ['application/json'];
    const httpHeaderAcceptSelected: string | undefined =
      this.configuration.selectHeaderAccept(httpHeaderAccepts);
    if (httpHeaderAcceptSelected != undefined) {
      headers['Accept'] = httpHeaderAcceptSelected;
    }

    // to determine the Content-Type header
    const consumes: string[] = ['application/json'];
    const httpContentTypeSelected: string | undefined =
      this.configuration.selectHeaderContentType(consumes);
    if (httpContentTypeSelected != undefined) {
      headers['Content-Type'] = httpContentTypeSelected;
    }
    return this.httpClient.post<TransferResponse>(
      `${this.basePath}/internal/transfer`,
      transferCommand,
      {
        withCredentials: this.configuration.withCredentials,
        headers: headers,
      },
    );
  }
}
